%%% Klasyka AI: Wieże Hanojskie


hanoi(N) :- move(N,left,middle,right).

move(1,L,_,R) :- out(L,R).
move(N,L,M,R) :-
	N1 is N-1, N1 > 0,
	move(N1,L,R,M),
       out(L,R),
	move(N1,M,L,R).

out(X,Y) :-
	write('Move a disk from '),
	write(X),
	write(' to '),
	write(Y), nl.
% eof
