:- dynamic(num/1).

%%% liczby.pl

%%% Prosty program ilustrujący ideę generacji/wyszukiwania rozwiazań w Prologu

% Fakty: definicja dostępnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).


% Przykładowa definicja liczby trzycyfrowej
   liczba(X):-
      cyfra(S),
      cyfra(D),
      cyfra(J),
      X is 100*S+10*D+J.


% Generacja i zapamiętanie liczb z zadanego zakresu

generate_and_assert(A,Z):-
   liczba(X),
   X >= A,
   X =< Z,
   assert(num(X)),
   fail.

generate_and_assert(_,_):-
   num(X),
   write(X),nl,
   fail.

generate_and_assert(_,_):-
   write('Done').

clear_numbers :-
   retract(num(_)),
   fail.

clear_numbers :-
   write('Done: empty').


% Modyfikacje:
% 1. Zmiana zakresu.
% 2. Zmiana kolejności.
% 3. Zmiana sposobu wypisywania.

% eof
