%%% Zastosowania praktyczne: symulacja układów cyfrowych


% Definicje działania bramek podstawowych
not(1,0).
not(0,1).

and(0,0,0).
and(0,1,0).
and(1,0,0).
and(1,1,1).

or(0,0,0).
or(0,1,1).
or(1,0,1).
or(1,1,1).

% Definicja przykładowego układu - xor

xor(Input1,Input2,Output) :-
	not(Input1,N1),
	not(Input2,N2),
	and(Input1,N2,N3),
	and(Input2,N1,N4),
	or(N3,N4,Output).


% Przykładowe testy:
% xor(1,0,W), xor(1,I,1), xor(I1,I2,0)

% eof

foo(I1,I2,I3,O1,O2) :-
   xor(I1,I2,X1),
   xor(X1,I3,O1),
   and(I1,I2,A1),
   and(X1,I3,A2),
   or(A1,A2,O2).
