

%%%%%%%%%%%%%%%%%  A Simple Deductive Database %%%%%%%%%%%%%%%%%%%%%%%%

mother(eva,nadjed).
father(john,tom).
father(john,ted).
father(john,eva).
father(ted,jimmy).
man(tom).
man(ted).
woman(eva).

parent(X,Y):- father(X,Y).
parent(X,Y):- mother(X,Y).

brother(B,X):-
   parent(P,B),
   parent(P,X),
   man(B),
   B \= X.

uncle(U,X):-
   parent(P,X),
   brother(U,P).


